// D import file generated from 'gl3n/frustum.d'
module gl3n.frustum;
private
{
	import gl3n.linalg : vec3, mat4, dot;
	import gl3n.math : abs, cradians;
	import gl3n.aabb : AABB;
	import gl3n.plane : Plane;
}
enum 
{
	OUTSIDE = 0,
	INSIDE,
	INTERSECT,
}
struct Frustum
{
	enum 
	{
		LEFT,
		RIGHT,
		BOTTOM,
		TOP,
		NEAR,
		FAR,
	}
	Plane[6] planes;
	nothrow pure @safe
	{
		inout @property ref inout(Plane) left() return;
		inout @property ref inout(Plane) right() return;
		inout @property ref inout(Plane) bottom() return;
		inout @property ref inout(Plane) top() return;
		inout @property ref inout(Plane) near() return;
		inout @property ref inout(Plane) far() return;
		this(mat4 mvp)
		{
			mvp.transpose();
			planes = [Plane(mvp[0][3] + mvp[0][0], mvp[1][3] + mvp[1][0], mvp[2][3] + mvp[2][0], mvp[3][3] + mvp[3][0]), Plane(mvp[0][3] - mvp[0][0], mvp[1][3] - mvp[1][0], mvp[2][3] - mvp[2][0], mvp[3][3] - mvp[3][0]), Plane(mvp[0][3] + mvp[0][1], mvp[1][3] + mvp[1][1], mvp[2][3] + mvp[2][1], mvp[3][3] + mvp[3][1]), Plane(mvp[0][3] - mvp[0][1], mvp[1][3] - mvp[1][1], mvp[2][3] - mvp[2][1], mvp[3][3] - mvp[3][1]), Plane(mvp[0][3] + mvp[0][2], mvp[1][3] + mvp[1][2], mvp[2][3] + mvp[2][2], mvp[3][3] + mvp[3][2]), Plane(mvp[0][3] - mvp[0][2], mvp[1][3] - mvp[1][2], mvp[2][3] - mvp[2][2], mvp[3][3] - mvp[3][2])];
			normalize();
		}
		this(Plane[6] planes)
		{
			this.planes = planes;
			normalize();
		}
		private void normalize();
		const int intersects(AABB aabb);
		const bool opBinaryRight(string s : "in")(AABB aabb)
		{
			return intersects(aabb) > 0;
		}
	}
}
